package PScm;

use strict;
use warnings;
use PScm::Read;
use PScm::Env;
use PScm::Primitive;
use PScm::SpecialForm;
use FileHandle;

require Exporter;

our @ISA    = qw(Exporter);
our @EXPORT = qw(ReadEvalPrint);

=head1 NAME

PScm - PScm interpreter written in Perl

=head1 SYNOPSIS

  use PScm;
  ReadEvalPrint($in_filehandle[, $out_filehandle]);

=head1 DESCRIPTION

Just messing about, A toy lisp interpreter.

=cut

sub ReadEvalPrint {
    my ($infh, $outfh) = @_;

    $outfh ||= new FileHandle(">-");
    my $reader = new PScm::Read($infh);
    while (defined(my $expr = $reader->Read)) {
        my $result = $expr->Eval(
            new PScm::Env(
                let => new PScm::SpecialForm::Let(),
                '*' => new PScm::Primitive::Multiply(),
                '-' => new PScm::Primitive::Subtract(),
                if  => new PScm::SpecialForm::If(),
            )
        );
        $result->Print($outfh);
    }
}

sub Print {
    my ($expr, $outfh) = @_;
    print $outfh $expr->as_string, "\n";
}

sub as_string { ref($_[0]); }

sub new { bless {}, $_[0] }

1;
