package PScm::Env;

use strict;
use warnings;
use base qw(PScm);

sub new {
    my ($class, %bindings) = @_;

    $class = ref($class) || $class;
    bless { bindings => {%bindings}, parent => 0 }, $class;
}

sub Extend {
    my ($self, $ra_symbols, $ra_values) = @_;

    my %bindings = ();
    my @names    = map { $_->value } @$ra_symbols;
    @bindings{@names} = map { $_->Eval($self) } @$ra_values;
    my $new = $self->new(%bindings);
    $new->{parent} = $self;
    return $new;
}

sub LookUp {
    my ($self, $symbol) = @_;

    if (exists($self->{bindings}{ $symbol->value })) {
        return $self->{bindings}{ $symbol->value };
    } elsif ($self->{parent}) {
        return $self->{parent}->LookUp($symbol);
    } else {
        die "no binding for @{[$symbol->value]} ",
          "in @{[ref($self)]}\n";
    }
}

1;
